-- -------------------------------------------------------------
-- TablePlus 4.2.0(388)
--
-- https://tableplus.com/
--
-- Database: resonate_test
-- Generation Time: 2021-09-23 17:30:54.4590
-- -------------------------------------------------------------


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;






DROP TABLE IF EXISTS `credits`;
CREATE TABLE `credits` (
  `cid` int NOT NULL AUTO_INCREMENT,
  `uid` int DEFAULT NULL,
  `total` int DEFAULT NULL,
  PRIMARY KEY (`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `favorites`;
CREATE TABLE `favorites` (
  `fid` int NOT NULL AUTO_INCREMENT,
  `tid` int DEFAULT NULL,
  `uid` int DEFAULT NULL,
  `type` int DEFAULT NULL,
  PRIMARY KEY (`fid`),
  KEY `idx_tid_uid` (`tid`,`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `files`;
CREATE TABLE `files` (
  `id` char(36) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `filename` varchar(255) DEFAULT NULL,
  `filename_prefix` varchar(255) DEFAULT NULL,
  `owner_id` int NOT NULL,
  `description` varchar(255) DEFAULT NULL,
  `size` int DEFAULT NULL,
  `hash` varchar(64) DEFAULT NULL,
  `status` enum('processing','errored','ok') NOT NULL DEFAULT 'processing',
  `mime` enum('audio/aac','audio/aiff','audio/mp4','audio/vnd.wave','audio/x-flac','audio/x-m4a','image/png','image/jpeg','text/csv') DEFAULT NULL,
  `metadata` text,
  `updated_at` datetime NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `images`;
CREATE TABLE `images` (
  `iid` int NOT NULL AUTO_INCREMENT,
  `uid` int DEFAULT NULL,
  `name` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`iid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `orders`;
CREATE TABLE `orders` (
  `oid` int NOT NULL AUTO_INCREMENT,
  `uid` int DEFAULT NULL,
  `pstatus` int DEFAULT NULL,
  `ostatus` int DEFAULT NULL,
  `type` int DEFAULT NULL,
  `date` int DEFAULT NULL,
  `currency` varchar(10) DEFAULT NULL,
  `amount` double DEFAULT NULL,
  `txid` varchar(250) DEFAULT NULL,
  `vat` int DEFAULT NULL,
  `details` text,
  PRIMARY KEY (`oid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `playlists`;
CREATE TABLE `playlists` (
  `pid` int NOT NULL AUTO_INCREMENT,
  `uid` int DEFAULT NULL,
  `playlist_name` varchar(250) DEFAULT NULL,
  `details` longtext,
  PRIMARY KEY (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `plays`;
CREATE TABLE `plays` (
  `pid` int NOT NULL AUTO_INCREMENT,
  `tid` int DEFAULT NULL,
  `uid` int DEFAULT NULL,
  `event` int DEFAULT NULL,
  `date` int DEFAULT NULL,
  `coords` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`pid`),
  KEY `idx_tid_uid_event` (`tid`,`uid`,`event`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `tags`;
CREATE TABLE `tags` (
  `tagid` int NOT NULL AUTO_INCREMENT,
  `tid` int DEFAULT NULL,
  `tagnames` mediumtext,
  PRIMARY KEY (`tagid`),
  KEY `idx_tid_tagnames` (`tid`,`tagnames`(256)),
  FULLTEXT KEY `tracks_search_tags` (`tagnames`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `track_group_items`;
CREATE TABLE `track_group_items` (
  `id` char(36) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `index` int NOT NULL DEFAULT '0',
  `track_group_id` char(36) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `track_id` int DEFAULT NULL,
  `track_performers` varchar(255) DEFAULT NULL,
  `track_composers` varchar(255) DEFAULT NULL,
  `updated_at` datetime NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `track_groups`;
CREATE TABLE `track_groups` (
  `id` char(36) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `cover` char(36) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `title` varchar(255) NOT NULL,
  `type` enum('lp','ep','single','playlist','compilation','collection') DEFAULT NULL,
  `about` text,
  `private` tinyint(1) NOT NULL DEFAULT '1',
  `display_artist` varchar(255) DEFAULT NULL,
  `creator_id` int DEFAULT NULL,
  `composers` text,
  `performers` text,
  `tags` text,
  `release_date` date DEFAULT NULL,
  `download` tinyint(1) DEFAULT '0',
  `updated_at` datetime NOT NULL,
  `created_at` datetime NOT NULL,
  `featured` tinyint(1) DEFAULT '0',
  `slug` varchar(255) DEFAULT NULL,
  `enabled` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tracks`;
CREATE TABLE `tracks` (
  `tid` int NOT NULL AUTO_INCREMENT,
  `uid` int DEFAULT NULL,
  `track_artist` varchar(250) DEFAULT NULL,
  `track_name` varchar(250) DEFAULT NULL,
  `track_album` varchar(250) DEFAULT NULL,
  `track_duration` varchar(15) DEFAULT NULL,
  `track_url` varchar(500) DEFAULT NULL,
  `track_cover_art` varchar(500) DEFAULT NULL,
  `status` int DEFAULT NULL,
  `event` varchar(10) DEFAULT NULL,
  `track_album_artist` varchar(250) DEFAULT NULL,
  `track_composer` varchar(250) DEFAULT NULL,
  `track_year` int DEFAULT NULL,
  `total_tracks` int DEFAULT NULL,
  `track_number` int DEFAULT NULL,
  `album_number` int DEFAULT NULL,
  `album_total` int DEFAULT NULL,
  `date` int DEFAULT NULL,
  PRIMARY KEY (`tid`),
  KEY `idx_track_status_uid_key` (`uid`,`status`),
  FULLTEXT KEY `tracks_search` (`track_artist`,`track_name`,`track_album`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE DEFINER=`root`@`localhost` FUNCTION `rs_set_cost`(startCount INT, count INT) RETURNS int
    READS SQL DATA
    DETERMINISTIC
BEGIN
  DECLARE paid INT;
  DECLARE i INT;
  SET paid = 0;
  SET i = startCount;

  IF count >= 9 THEN
    SET paid = 1022;
    return paid;
  END IF;

  WHILE i < (count + startCount) DO
    SET paid = paid + rs_set_credits_for_play(i);
    SET i = i + 1;
  END WHILE;
  
  RETURN paid;
END;
CREATE DEFINER=`root`@`localhost` FUNCTION `rs_set_credits_for_play`(count INT) RETURNS int
    READS SQL DATA
    DETERMINISTIC
BEGIN
  DECLARE credit INT;
  DECLARE i INT;
  SET credit = 2;
  SET i = 0;

  IF count >= 9 THEN
    SET credit = 0;
    return credit;
  END IF;
  
  WHILE i < count DO
  SET credit = credit * 2;
  SET i = i + 1;
  END WHILE;
  
  RETURN credit;
END;


/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;